<?php

namespace Creativestyle\ContentConstructorAssetExtension\Test\Integration\Service;

class AssetLocatorTest extends \PHPUnit\Framework\TestCase
{
    /**
     * @var \Creativestyle\ContentConstructor\AssetLocator
     */
    private $locator;

    /**
     * @var \Magento\TestFramework\ObjectManager
     */
    private $objectManager;

    public function setUp() {
        $this->objectManager = \Magento\TestFramework\ObjectManager::getInstance();

        $this->locator = $this->objectManager
            ->get(\Creativestyle\ContentConstructorAssetExtension\Service\AssetLocator::class);

    }

    /**
     * @magentoAppArea adminhtml
     */
    public function testItReturnsCorrectUrlForAdminArea() {
        $url = $this->prepareRegexUrl('http://localhost/pub/static/version([0-9]+?)/adminhtml/Magento/backend/en_US/Creativestyle_ContentConstructorAssetExtension/images/sprites.svg');

        $this->assertRegExp(
            $url,
            $this->locator->getUrl('images/sprites.svg')
        );
    }

    /**
     * @magentoAppArea frontend
     */
    public function testItReturnsCorrectUrlForFrontend() {
        $url = $this->prepareRegexUrl('http://localhost/pub/static/version([0-9]+?)/frontend/Magento/luma/en_US/images/sprites.svg');

        $this->assertRegExp(
            $url,
            $this->locator->getUrl('images/sprites.svg')
        );
    }

    protected function prepareRegexUrl($url) {
        $url = str_replace('/', '\/', $url);
        return sprintf('/%s/', $url);
    }
}